<?php
 


class Limex_Advr_Block_Adminhtml_Catalog_Lowstock
    extends Limex_Advr_Block_Adminhtml_Catalog_Abstract
{
    public function _prepareLayout()
    {
        parent::_prepareLayout();
        
        $this->setHeaderText(Mage::helper('advr')->__('Low stock'));

        return $this;
    }

    protected function _prepareChart()
    {
        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultSort('product_stock_qty')
            ->setDefaultDir('asc')
            ;

        return $this;
    }

    protected function _prepareCollection()
    {
        $collection = Mage::getModel('advr/report_sales')
            ->setBaseTable('catalog/product')
            ->setFilterData($this->getFilterData())
            ->selectColumns(array_merge(
                array('product_id'),
                $this->getVisibleColumns())
            )
            ->groupByColumn('product_id')
            ;

        // echo Limex_SqlFormatter::format($collection->getSelect());

        return $collection;
    }

    public function getColumns()
    {
        $columns = array(
            'product_sku' => array(
                'header'              => 'SKU',
                'type'                => 'text',
                'totals_label'        => 'Total',
                'filter_totals_label' => 'Subtotal',
                'link_callback'       => array($this, 'rowUrlCallback'),
            ),

            'product_name' => array(
                'header'         => 'Product',
            ),

            'product_stock_qty' => array(
                'header'              => 'Stock Quantity',
                'type'                => 'number',
            ),

            'product_is_in_stock' => array(
                'header'              => 'Stock Availability',
                'type'                => 'options',
                'options'             => Mage::getSingleton('advr/system_config_source_stock')->toOptionHash(),
            ),
        );

        $columns += $this->getBaseProductColumns(true);

        $columns['actions'] = array(
            'header'       => 'Actions',
            'actions'      => array(
                array(
                    'caption'  => Mage::helper('advr')->__('View Product'),
                    'callback' => array($this, 'rowUrlCallback')
                ),
            ),
        );

        return $columns;
    }

    // public function _initToolbar()
    // {
    //     parent::_initToolbar();

    //     $form = $this->_toolbar->getForm();

    //     $form->addField('group_by_parent', 'checkbox', array(
    //         'name'    => 'group_by_parent',
    //         'label'   => Mage::helper('advr')->__('Group By Parent Product'),
    //         'value'   => 1,
    //         'checked' => $this->getFilterData()->getGroupByParent(),
    //     ));

    //     return $this;
    // }

    public function rowUrlCallback($row)
    {
        return $this->getUrl('adminhtml/catalog_product/edit', array('id' => $row->getData('product_id')));
    }
}